// Delegate.h: interface for the CDelegate class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DELEGATE_H__4EBA8CA4_6A7D_40B7_8586_680C8F95100C__INCLUDED_)
#define AFX_DELEGATE_H__4EBA8CA4_6A7D_40B7_8586_680C8F95100C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CDelegate : public CBLContext
{
DECLARE_DYNCREATE(CDelegate);
public:
	void DeleteMethodsByKey(CValue **ppParams);
	bool InvokeByKey(CValue &RetVal, CValue **ppParams);
	bool IsEmpty();
	void SetTypeOfDelegate(CValue **ppParams);
	void EraseDelegate(bool bFullErase = true);
	bool Invoke(CValue &RetVal, CValue **ppParams, bool IsBreakest = false);
	bool DeleteMethodsFromDelegate(CValue &RetVal, CValue * *pParams);
	bool AddMethodForDelegate(class CValue &RetVal,class CValue * *ppParams, bool isKeyMapped = true);
	int IsDelagateRetVal();
	int GetNParamsOfDelegate();
	CDelegate();
	virtual ~CDelegate();
  enum {    
    methDefineType,
    methAddMethod,
    methRemMethod,
    methRemMethodByKey,
    methInvoke,
    funcInvokeByKey,
    procErase,
    funcIsEmpty,
	  lastMethod
	};
  static struct paramdefs {
		char * Names[2];
		int HasReturnValue;
		int NumberOfParams;
	}  defFnNames[];
  virtual int  CallAsFunc(int,class CValue &,class CValue * *);	//935
	virtual int  CallAsProc(int,class CValue * *);	//937
	virtual void  DecrRef(void);	//1086
	virtual int  FindMethod(char const *)const;	//1366
	virtual int  FindProp(char const *)const;	//1369
	virtual char const *  GetCode(void)const;	//1544
	virtual int  GetDestroyUnRefd(void)const;	//1657
	virtual void  GetExactValue(class CValue &);	//1708
	virtual class CObjID   GetID(void)const;	//1804
	virtual class CBLContextInternalData *  GetInternalData(void);	//1826
	virtual char const *  GetMethodName(int,int)const;	//1964
	virtual int  GetNMethods(void)const;	//2005
	virtual int  GetNParams(int)const;	//2008
	virtual int  GetNProps(void)const;	//2015
	virtual int  GetParamDefValue(int,int,class CValue *)const;	//2122
	virtual char const *  GetPropName(int,int)const;	//2187
	virtual int  GetPropVal(int,class CValue &)const;	//2221
	virtual long  GetTypeID(void)const;	//2505
	virtual char const *  GetTypeString(void)const;	//2513
	virtual class CType   GetValueType(void)const;	//2547
	virtual int  HasRetVal(int)const;	//2657
	virtual void  IncrRef(void);	//2668
	virtual void  InitObject(class CType const &);	//2721
	virtual void  InitObject(char const *);	//2722
	virtual int  IsExactValue(void)const;	//2808
	virtual int  IsOleContext(void)const;	//2846
	virtual int  IsPropReadable(int)const;	//2863
	virtual int  IsPropWritable(int)const;	//2865
	virtual int  IsSerializable(void);	//2874
	virtual int  SaveToString(class CString &);	//3295
	virtual void  SelectByID(class CObjID,long);	//3350
	virtual int  SetPropVal(int,class CValue const &);	//3694

	static class CObjID ObjID;  
private:
  struct InfoEventHandlers {
    CBLContext * pBLCont;
    int nNumMethOfCall;
    InfoEventHandlers() : pBLCont(NULL), nNumMethOfCall(-1) {}
    InfoEventHandlers(CBLContext *p, int n) : pBLCont(p), nNumMethOfCall(n) {}
    bool operator == (const InfoEventHandlers& rhs)
    {
      return (pBLCont == rhs.pBLCont && nNumMethOfCall == rhs.nNumMethOfCall);
    }        
  };
	list<InfoEventHandlers> m_ListOfHandlers;
  typedef list<InfoEventHandlers>::iterator ITER_LIST;
  typedef list<InfoEventHandlers>::const_iterator CONST_ITER_LIST;  
  list<int> m_ListInt;
  int m_nCountParams;
  int m_IsFunc;
  CMapStringToPtr m_map;
};

#endif // !defined(AFX_DELEGATE_H__4EBA8CA4_6A7D_40B7_8586_680C8F95100C__INCLUDED_)
